public inbox for gentoo-commits@lists.gentoo.org
 help / color / mirror / Atom feed
From: "Sam James" <sam@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: dev-lang/zig/
Date: Wed, 05 Mar 2025 11:40:41 +0000 (UTC)	[thread overview]
Message-ID: <1741174678.bf825c6fb33c69e3bd144efa9c7b17c4672ae1fd.sam@gentoo> (raw)

commit:     bf825c6fb33c69e3bd144efa9c7b17c4672ae1fd
Author:     Eric Joldasov <bratishkaerik <AT> landless-city <DOT> net>
AuthorDate: Wed Mar  5 08:47:18 2025 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Wed Mar  5 11:37:58 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=bf825c6f

dev-lang/zig: add 0.14.0

Signed-off-by: Eric Joldasov <bratishkaerik <AT> landless-city.net>
Closes: https://github.com/gentoo/gentoo/pull/40909
Signed-off-by: Sam James <sam <AT> gentoo.org>

 dev-lang/zig/Manifest          |   2 +
 dev-lang/zig/zig-0.14.0.ebuild | 352 +++++++++++++++++++++++++++++++++++++++++
 2 files changed, 354 insertions(+)

diff --git a/dev-lang/zig/Manifest b/dev-lang/zig/Manifest
index 3126303a057c..9fa4f6de4918 100644
--- a/dev-lang/zig/Manifest
+++ b/dev-lang/zig/Manifest
@@ -1,3 +1,5 @@
 DIST zig-0.13.0-llvm-18.1.8-r6-fix.patch 45968 BLAKE2B a07c47b22b079d324b200fe84af5c89ffe51a1c81f50ca894a80f9f9db51a9d4119ae51c2e4e84a9b4f0111b2b809978b88adca42480ee800693afbd78f47387 SHA512 148b3f4807763dfb6a4d4e201890fa8204deaf73e620a8b592dfa03b997bc16ed01ea26e4d85f242473e91ccc45b1a06af22f786851f8e26cec1ac821b14efdc
 DIST zig-0.13.0.tar.xz 17220728 BLAKE2B f4bbacc2012950c556bebc28fc322fc6424bf20fe118e8362373336b6460e514028978584087f6e7f25ed8b8e6991610edce625676a1dd80c1975c5f9ef48775 SHA512 6f5f31f4ba71a11d8b16c7a5a613e124095e503fa6b02d2b77e5b177674c739287e81d98d96dc261fed24bc836caf196f71c3fcc7a6518387df86ba9e03df4dd
 DIST zig-0.13.0.tar.xz.minisig 312 BLAKE2B 2d061257c9c75f9c36b01cfb08dcd2040538a125b9ea2cae8617ae5496e685b165933ce8981494419522b7e19b51fc69a651ecaa4a8930753acf2e4ae3d6e00f SHA512 21c6139c06cba6c5e23a3305fed0c0f1b9b32d9140bd686c26365ce0279d5f53cd081894eaba29f0c1ed51b2e831edf7bd4ae6a7eaee5018a252e312e9b65507
+DIST zig-0.14.0.tar.xz 17772188 BLAKE2B 139a9d48c0a324f64633c71c7d572a60f817d11be9ea0c5cd837cdb78239969be581e51403b75790bbb95cc9c0111bd966134d4f2652863bb2a3f61d65afa531 SHA512 046462526ec16d56e8dcead8f8b680e99101090766c443f512f308c25860e8416f6fb2be15d4a387baa94f63a6fea6255374874c1ccf19144facbc02226a503b
+DIST zig-0.14.0.tar.xz.minisig 312 BLAKE2B aba72ba97a978a84e9a938d2641c089a2c5f577041b8a777b9d4b8f7ee2d0b13cd03ccafcd5b4e627ba5fdff6592ca4ead2afa111b4cb769b66ed584b6e085e2 SHA512 a5d0946f136b2a28efbfde77f6052cd8745147df64bb70ed30d1d79bad27a52af451631750d592134e1933763ebe5e24215459481864bec0a969c1730527dc2c

diff --git a/dev-lang/zig/zig-0.14.0.ebuild b/dev-lang/zig/zig-0.14.0.ebuild
new file mode 100644
index 000000000000..af0fe7f8192b
--- /dev/null
+++ b/dev-lang/zig/zig-0.14.0.ebuild
@@ -0,0 +1,352 @@
+# Copyright 2019-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+LLVM_COMPAT=( 19 )
+LLVM_OPTIONAL=1
+
+ZIG_SLOT="$(ver_cut 1-2)"
+ZIG_OPTIONAL=1
+
+inherit check-reqs cmake flag-o-matic edo llvm-r2 toolchain-funcs zig
+
+DESCRIPTION="A robust, optimal, and maintainable programming language"
+HOMEPAGE="https://ziglang.org/ https://github.com/ziglang/zig/"
+if [[ ${PV} == 9999 ]]; then
+	EGIT_REPO_URI="https://github.com/ziglang/zig.git"
+	inherit git-r3
+else
+	VERIFY_SIG_METHOD=minisig
+	VERIFY_SIG_OPENPGP_KEY_PATH=/usr/share/minisig-keys/zig-software-foundation.pub
+	inherit verify-sig
+
+	SRC_URI="
+		https://ziglang.org/download/${PV}/${P}.tar.xz
+		verify-sig? ( https://ziglang.org/download/${PV}/${P}.tar.xz.minisig )
+	"
+	KEYWORDS="~amd64 ~arm ~arm64"
+
+	BDEPEND="verify-sig? ( sec-keys/minisig-keys-zig-software-foundation )"
+fi
+
+# project itself: MIT
+# There are bunch of projects under "lib/" folder that are needed for cross-compilation.
+# Files that are unnecessary for cross-compilation are removed by upstream
+# and therefore their licenses (if any special) are not included.
+# lib/libunwind: Apache-2.0-with-LLVM-exceptions || ( UoI-NCSA MIT )
+# lib/libcxxabi: Apache-2.0-with-LLVM-exceptions || ( UoI-NCSA MIT )
+# lib/libcxx: Apache-2.0-with-LLVM-exceptions || ( UoI-NCSA MIT )
+# lib/libc/wasi: || ( Apache-2.0-with-LLVM-exceptions Apache-2.0 MIT BSD-2 ) public-domain
+# lib/libc/musl: MIT BSD-2
+# lib/libc/mingw: ZPL public-domain BSD-2 ISC HPND
+# lib/libc/glibc: BSD HPND ISC inner-net LGPL-2.1+
+LICENSE="MIT Apache-2.0-with-LLVM-exceptions || ( UoI-NCSA MIT ) || ( Apache-2.0-with-LLVM-exceptions Apache-2.0 MIT BSD-2 ) public-domain BSD-2 ZPL ISC HPND BSD inner-net LGPL-2.1+"
+SLOT="${ZIG_SLOT}"
+IUSE="debug doc +llvm"
+REQUIRED_USE="
+	!llvm? ( !doc )
+	llvm? ( ${LLVM_REQUIRED_USE} )
+"
+RESTRICT="!llvm? ( test )"
+
+# Used by both "cmake" and "zig" eclasses.
+BUILD_DIR="${WORKDIR}/${P}_build"
+
+# Zig requires zstd and zlib compression support in LLVM, if using LLVM backend.
+# (non-LLVM backends don't require these)
+# They are not required "on their own", so please don't add them here.
+# You can check https://github.com/ziglang/zig-bootstrap in future, to see
+# options that are passed to LLVM CMake building (excluding "static" ofc).
+LLVM_DEPEND="$(llvm_gen_dep '
+	llvm-core/clang:${LLVM_SLOT}
+	llvm-core/lld:${LLVM_SLOT}[zstd]
+	llvm-core/llvm:${LLVM_SLOT}[zstd]
+')"
+
+BDEPEND+=" llvm? ( ${LLVM_DEPEND} )"
+DEPEND="llvm? ( ${LLVM_DEPEND} )"
+RDEPEND="${DEPEND}"
+IDEPEND="app-eselect/eselect-zig"
+
+DOCS=( "README.md" "doc/build.zig.zon.md" )
+
+# zig.eclass does not set this for us since we use ZIG_OPTIONAL=1
+QA_FLAGS_IGNORED="usr/.*/zig/${PV}/bin/zig"
+
+# Since commit https://github.com/ziglang/zig/commit/e7d28344fa3ee81d6ad7ca5ce1f83d50d8502118
+# Zig uses self-hosted compiler only
+CHECKREQS_MEMORY="4G"
+
+pkg_setup() {
+	# Skip detecting zig executable.
+	declare -r -g ZIG_VER="${PV}"
+	ZIG_EXE="not-applicable" zig_pkg_setup
+
+	declare -r -g ZIG_SYS_INSTALL_DEST="${EPREFIX}/usr/$(get_libdir)/zig/${PV}"
+
+	if use llvm; then
+		[[ ${MERGE_TYPE} != binary ]] && llvm_cbuild_setup
+	fi
+
+	# Requires running stage3 which is built for cross-target.
+	if use doc && tc-is-cross-compiler; then
+		die "USE=doc is not yet supported when cross-compiling"
+	fi
+
+	check-reqs_pkg_setup
+}
+
+src_unpack() {
+	if [[ ${PV} == 9999 ]]; then
+		git-r3_src_unpack
+	else
+		if use verify-sig; then
+			verify-sig_verify_detached "${DISTDIR}"/${P}.tar.xz{,.minisig}
+		fi
+	fi
+	zig_src_unpack
+}
+
+src_prepare() {
+	if use llvm; then
+		cmake_src_prepare
+	else
+		# Sync with zig_src_prepare
+		default_src_prepare
+		mkdir -p "${BUILD_DIR}" || die
+		einfo "BUILD_DIR: \"${BUILD_DIR}\""
+		# "--system" mode is not used during bootstrap.
+	fi
+
+	# Remove "limit memory usage" flags, it's already verified by
+	# CHECKREQS_MEMORY and causes unneccessary errors. Upstream set them
+	# according to CI OOM failures, which are not applicable to normal Gentoo build.
+	sed -i -e '/\.max_rss = .*,/d' build.zig || die
+}
+
+src_configure() {
+	# Has no effect on final binary and only causes failures during bootstrapping.
+	filter-lto
+
+	# Used during bootstrapping. stage1/stage2 have limited functionality
+	# and can't resolve native target, so we pass target in exact form.
+	declare -r -g ZIG_HOST_AS_TARGET="$(zig-utils_c_env_to_zig_target "${CBUILD:-${CHOST}}" "${CFLAGS}"})"
+
+	# Note that if we are building with CMake, "my_zbs_args"
+	# are used only after compiling zig2.
+	local my_zbs_args=(
+		--zig-lib-dir "${S}/lib/"
+
+		--prefix "${ZIG_SYS_INSTALL_DEST}/"
+		--prefix-lib-dir lib/
+
+		# These are built separately
+		-Dno-langref=true
+		-Dstd-docs=false
+
+		# More commands and options if "debug" is enabled.
+		-Ddebug-extensions=$(usex debug true false)
+		# More asserts and so on by default if "debug" is enabled.
+		--release=$(usex debug safe fast)
+	)
+
+	# Scenarios of compilation:
+
+	# With LLVM, native:
+	# CMake:
+	#   * generate "config.h" for LLVM libraries and build "zigcpp"
+	#   * build "zig2" using common "config.h" and "zigcpp"
+	# build.zig:
+	#   * build "stage3" using common "config.h" and "zigcpp"
+
+	# With LLVM, cross-compiled:
+	# CMake:
+	#   * generate cross-target "config.h" for LLVM libraries from ESYSROOT
+	#     and build cross-target "zigcpp", and stash them away
+	#   * generate native "config.h" for LLVM libraries from BROOT and
+	#     build native "zigcpp"
+	#   * build native "zig2" using native "config.h" and "zigcpp"
+	# build.zig:
+	#   * build cross-target "stage3" using stashed "config.h" and "zigcpp"
+
+	# Without LLVM:
+	# bootstrap.c:
+	#   * build native "zig2"
+	# build.zig:
+	#   * build (cross-)target "stage3"
+
+	if use llvm; then
+		my_zbs_args+=(
+			-Denable-llvm=true
+			-Dstatic-llvm=false
+			-Dconfig_h="${BUILD_DIR}/config.h"
+		)
+	else
+		my_zbs_args+=(
+			-Denable-llvm=false
+		)
+	fi
+	zig_src_configure
+
+	if use llvm; then
+		local mycmakeargs=(
+			-DZIG_SHARED_LLVM=ON
+			-DZIG_USE_LLVM_CONFIG=ON
+			-DZIG_HOST_TARGET_TRIPLE="${ZIG_HOST_AS_TARGET}"
+			# Don't set ZIG_TARGET_TRIPLE, ZIG_TARGET_MCPU and
+			# CMAKE_INSTALL_PREFIX because we build up to zig2 max,
+			# after that "zig build" is used to compile stage3.
+
+			# Don't set CMAKE_PREFIX_PATH because "llvm_chost_setup"
+			# and "llvm_cbuild_setup" already set PATH in such way
+			# that suitable llvm-config is found and used in
+			# "cmake/Findllvm.cmake", and "cmake.eclass" help with
+			# cross-compilation pathes for "Findclang" and "Findlld".
+
+			# CMP0144, Zig has own packages with these names, so ignore
+			# LLVM_ROOT, Clang_ROOT, LLD_ROOT from "llvm_chost_setup".
+			-DCMAKE_FIND_USE_PACKAGE_ROOT_PATH=OFF
+		)
+		if tc-is-cross-compiler; then
+			# Enable cross-compilation for CMake when filling "config.h"
+			# and building "zigcpp". They would be used for stage3 build.
+			# Here we are using LLVM from ESYSROOT/DEPEND.
+			# Uses script llvm-config.
+
+			# Isolate PATH changes in subshell so that it would not
+			# affect next `cmake_src_configure` with BROOT/BDEPEND.
+			(
+				llvm_chost_setup
+				cmake_src_configure
+				cmake_build zigcpp
+			)
+
+			mv "${BUILD_DIR}/config.h" "${T}/target_config.h" || die
+			mv "${BUILD_DIR}/zigcpp/" "${T}/target_zigcpp/" || die
+			rm -rf "${BUILD_DIR}" || die
+		fi
+
+		# Force disable cross-compilation for CMake when building "zig2".
+		# Here we are using LLVM from BROOT/BDEPEND.
+		# Uses native llvm-config.
+
+		# Isolate environment changes in subshell so that it would not
+		# affect next phases.
+		(
+			export BUILD_CFLAGS="${CFLAGS}"
+			export BUILD_CXXFLAGS="${CXXFLAGS}"
+			export BUILD_CPPFLAGS="${CPPFLAGS}"
+			export BUILD_LDFLAGS="${LDFLAGS}"
+			tc-env_build
+
+			unset SYSROOT
+			export CHOST="${CBUILD:-${CHOST}}"
+			strip-unsupported-flags
+			cmake_src_configure
+		)
+	fi
+}
+
+src_compile() {
+	if use llvm; then
+		cmake_build zig2
+
+		if tc-is-cross-compiler; then
+			rm -rf "${BUILD_DIR}/zigcpp/" || die
+			rm -f "${BUILD_DIR}/config.h" || die
+
+			mv "${T}/target_zigcpp/" "${BUILD_DIR}/zigcpp/" || die
+			mv "${T}/target_config.h" "${BUILD_DIR}/config.h" || die
+		fi
+	else
+		cd "${BUILD_DIR}" || die
+		ln -s "${S}/stage1/" . || die
+		ln -s "${S}/src/" . || die
+		ln -s "${S}/lib/" . || die
+
+		local native_cc="$(tc-getBUILD_CC)"
+		"${native_cc}" -o bootstrap "${S}/bootstrap.c" || die "Zig's bootstrap.c compilation failed"
+		ZIG_HOST_TARGET_TRIPLE="${ZIG_HOST_AS_TARGET}" CC="${native_cc}" edo ./bootstrap
+	fi
+
+	cd "${BUILD_DIR}" || die
+	ZIG_EXE="./zig2" zig_src_compile --prefix stage3/
+
+	# Requires running stage3 which is built for cross-target.
+	if ! tc-is-cross-compiler; then
+		./stage3/bin/zig env || die "Zig compilation failed"
+
+		if use doc; then
+			ZIG_EXE="./stage3/bin/zig" zig_src_compile langref --prefix docgen/
+		fi
+	fi
+}
+
+src_test() {
+	if has_version -b app-emulation/qemu; then
+		ewarn "QEMU executable was found on your building system."
+		ewarn "If you have qemu-binfmt (binfmt_misc) hooks enabled for"
+		ewarn "foreign architectures, Zig tests might fail."
+		ewarn "In this case, please disable qemu-binfmt and try again."
+	fi
+
+	cd "${BUILD_DIR}" || die
+
+	# XXX: When we pass a libc installation to Zig, it will fail to find
+	#      the bundled libraries for targets like aarch64-macos and
+	#      *-linux-musl. Zig doesn't run binaries for these targets when
+	#      -Dskip-non-native is passed, but they are still compiled, so
+	#      the test will fail. There's no way to disable --libc once passed,
+	#      so we need to strip it from ZBS_ARGS.
+	#      See: https://github.com/ziglang/zig/issues/22383
+	local args_backup=("${ZBS_ARGS[@]}")
+
+	for ((i = 0; i < ${#ZBS_ARGS[@]}; i++)); do
+		if [[ "${ZBS_ARGS[i]}" == "--libc" ]]; then
+			unset ZBS_ARGS[i]
+			unset ZBS_ARGS[i+1]
+			break
+		fi
+	done
+
+	# Run tests with Debug mode by default, like upstream does in CI,
+	# full test suite with other modes is in a sad state right now...
+	ZIG_EXE="./stage3/bin/zig" zig_src_test -Dskip-non-native --release=debug
+
+	ZBS_ARGS=("${args_backup[@]}")
+}
+
+src_install() {
+	use doc && local HTML_DOCS=( "${BUILD_DIR}/docgen/doc/langref.html" )
+
+	ZIG_EXE="./zig2" zig_src_install
+
+	cd "${D}/${ZIG_SYS_INSTALL_DEST}" || die
+	mv lib/zig/ lib2/ || die
+	rm -rf lib/ || die
+	mv lib2/ lib/ || die
+	dosym -r "${ZIG_SYS_INSTALL_DEST}/bin/zig" /usr/bin/zig-${PV}
+}
+
+pkg_postinst() {
+	eselect zig update ifunset || die
+
+	elog "Starting from 0.12.0, Zig no longer installs"
+	elog "precompiled standard library documentation."
+	elog "Instead, you can call \`zig std\` to compile it on-the-fly."
+	elog "It reflects all edits in standard library automatically."
+	elog "See \`zig std --help\` for more information."
+	elog "More details here: https://ziglang.org/download/0.12.0/release-notes.html#Redesign-How-Autodoc-Works"
+
+	if ! use llvm; then
+		elog "Currently, Zig built without LLVM support lacks some"
+		elog "important features such as most optimizations, @cImport, etc."
+		elog "They are listed under \"Building from Source without LLVM\""
+		elog "section of the README file from \"/usr/share/doc/${PF}\" ."
+	fi
+}
+
+pkg_postrm() {
+	eselect zig update ifunset
+}


             reply	other threads:[~2025-03-05 11:40 UTC|newest]

Thread overview: 74+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2025-03-05 11:40 Sam James [this message]
  -- strict thread matches above, loose matches on Subject: below --
2025-03-04 22:09 [gentoo-commits] repo/gentoo:master commit in: dev-lang/zig/ Sam James
2025-02-17  1:52 Sam James
2025-02-16 16:29 Sam James
2025-02-16 16:25 Sam James
2025-02-16 16:25 Sam James
2025-02-16 16:25 Sam James
2025-02-16 16:25 Sam James
2025-02-16 16:25 Sam James
2024-12-15  9:47 Sam James
2024-11-06 13:35 Sam James
2024-09-21  7:41 Michał Górny
2024-08-05  7:38 Joonas Niilola
2024-05-20  7:49 Sam James
2024-05-20  7:49 Sam James
2024-05-19 15:21 Sam James
2024-02-28  9:12 Florian Schmaus
2024-02-11 16:02 Michał Górny
2023-12-13  7:47 Florian Schmaus
2023-11-22 11:38 Sam James
2023-09-26 15:54 Sam James
2023-08-25  3:58 Jakov Smolić
2023-07-27 11:45 Sam James
2023-07-26  3:33 Sam James
2023-05-13  3:28 Sam James
2023-05-13  3:28 Sam James
2023-04-07  4:19 Michał Górny
2023-03-10  7:00 Florian Schmaus
2023-03-09 17:56 Florian Schmaus
2023-03-09 10:54 Florian Schmaus
2023-03-09 10:54 Florian Schmaus
2023-03-09 10:54 Florian Schmaus
2023-01-20  3:54 Sam James
2023-01-20  1:17 Sam James
2023-01-14 19:17 Sam James
2022-12-14  9:20 Sam James
2022-11-08  4:09 Sam James
2022-11-07  6:52 Sam James
2022-11-07  6:52 Sam James
2022-10-30  9:40 Sam James
2022-10-20 23:34 Sam James
2022-10-15 15:18 Sam James
2022-09-19  3:40 Sam James
2022-08-22  8:18 Jakov Smolić
2022-08-22  8:18 Jakov Smolić
2022-05-27  7:45 Joonas Niilola
2022-05-27  7:45 Joonas Niilola
2022-04-30  8:13 Joonas Niilola
2022-04-17 20:05 Sam James
2022-03-29 10:50 Ionen Wolkens
2022-03-29  7:20 Joonas Niilola
2022-03-28  7:51 Florian Schmaus
2022-03-28  7:50 Florian Schmaus
2022-03-08 13:17 Florian Schmaus
2021-12-25 17:27 Arthur Zamarin
2021-12-25 10:21 Sam James
2021-12-25 10:20 Sam James
2021-11-21  9:52 Michał Górny
2021-11-05 13:39 罗百科
2021-10-30 23:32 Sam James
2021-10-30 23:32 Sam James
2021-07-03 15:46 Joonas Niilola
2021-07-03 15:46 Joonas Niilola
2021-07-03 15:46 Joonas Niilola
2021-03-06 12:25 Michał Górny
2021-03-04 17:42 Joonas Niilola
2021-01-04  2:10 Matt Turner
2020-01-06 12:23 Andreas Sturmlechner
2019-10-01  6:14 Joonas Niilola
2019-09-20 16:18 Joonas Niilola
2019-09-08 15:59 Joonas Niilola
2019-08-07 18:28 Joonas Niilola
2019-08-02  9:07 Joonas Niilola
2019-08-02  8:37 Joonas Niilola

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1741174678.bf825c6fb33c69e3bd144efa9c7b17c4672ae1fd.sam@gentoo \
    --to=sam@gentoo.org \
    --cc=gentoo-commits@lists.gentoo.org \
    --cc=gentoo-dev@lists.gentoo.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox